module hc_sr04(
    clk    ,
    rst_n  ,
    echo   ,

    trig   ,
    s_g    ,
    s_s    ,
    s_b    ,
    s_q      
    );

   
    parameter      DATA_W = 14  ;
	parameter		 TIME_1S = 50_000_000;

    input               clk     ;
    input               rst_n   ;
    input               echo    ;

    output              trig    ;
    output[ 3:0]        s_g     ;    
    output[ 3:0]        s_s     ;    
    output[ 3:0]        s_b     ;    
    output[ 3:0]        s_q     ;    
 
	 
    wire                trig    ;
    reg   [ 3:0]        s_g     ;    
    reg   [ 3:0]        s_s     ;    
    reg   [ 3:0]        s_b     ;    
    reg   [ 3:0]        s_q     ;    
    reg   [DATA_W-1:0]  distance;
	 

    reg   [25:0]        cnt0    ;
    reg   [20:0]        h_cnt   ;
    reg                 echo_2  ;
    reg                 echo_1  ;
    wire                add_cnt0;
    wire                end_cnt0;	 
    wire                flag_h  ;
    wire                flag_l  ;
	 
   
	
    always @(posedge clk or negedge rst_n)begin
        if(!rst_n)begin
            cnt0 <= 0;
        end
        else if(add_cnt0)begin
            if(end_cnt0)
                cnt0 <= 0;
            else
                cnt0 <= cnt0 + 1'b1;
        end
    end

    assign add_cnt0 = 1;       
    assign end_cnt0 = add_cnt0 && cnt0 == TIME_1S - 1;
	
	
 
    assign trig = (cnt0>=500&&cnt0<1000)?1:0;


    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            echo_1 <= 0;
            echo_2 <= 0;
        end
        else begin
            echo_1 <= echo  ;
            echo_2 <= echo_1;
        end
    end

    always @(posedge clk or negedge rst_n)begin
        if(!rst_n)begin
            h_cnt <= 0;
        end
        else if(add_h_cnt)begin
            if(end_h_cnt)
                h_cnt <= 0;
            else
                h_cnt <= h_cnt + 1;
        end
        else if(end_cnt0)begin
            h_cnt <= 0;
        end
    end

    assign add_h_cnt = echo_2;       
    assign end_h_cnt = 0 ;   


    
    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            distance <= 0;
        end
        else if(add_cnt0 && cnt0 == 45_000_000-1)begin
            distance <= h_cnt*34/10000;
        end
    end



     always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            s_g <= 0;
        end
        else begin
            s_g <= distance%10;
        end
    end


    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            s_s <= 0;
        end
        else begin
            s_s <= (distance/10)%10;
        end
    end  


    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            s_b <= 0;
        end
        else begin
            s_b <= (distance/100)%10;
        end
    end


    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            s_q <= 0;
        end
        else begin
            s_q <= (distance/1000)%10;
        end

    end




endmodule
